package simple;

import org.simpleframework.xml.Serializer;
import org.simpleframework.xml.load.Persister;

import java.io.Serializable;
import java.io.StringWriter;


public class BaseRule implements Serializable {
    /**
     * Serialize the condition to XML string
     *
     * @return XML string
     */
    protected String toXML() {
        try {
            Serializer serializer = new Persister();
            StringWriter sw = new StringWriter();
            serializer.write(this, sw);
            return sw.toString();
        } catch (Exception e) {
            return null;
        }

    }

    /**
     * Build the rule from XML string
     *
     * @param xmlString XML string
     * @param clazz     Condition class to be de-serialized
     * @return Condition object
     */
    public static IRule fromXML(String xmlString, Class clazz) {
        try {
            Serializer serializer = new Persister();
            return (IRule)serializer.read(clazz, xmlString);
        } catch (Exception e) {
            return null;
        }
    }


}
